Package com.smartgwt.client.widgets

# Class RichTextEditor

java.lang.Object
com.google.gwt.user.client.ui.UIObject
com.google.gwt.user.client.ui.Widget
com.smartgwt.client.widgets.BaseWidget
com.smartgwt.client.widgets.Canvas
com.smartgwt.client.widgets.layout.Layout
com.smartgwt.client.widgets.layout.VLayout
com.smartgwt.client.widgets.RichTextEditor

All Implemented Interfaces:
  `HasAttachHandlers`, `HasHandlers`, `EventListener`, `HasVisibility`, `IsWidget`, `LogicalStructure`, `HasClearHandlers`, `HasClickHandlers`, `HasDoubleClickHandlers`, `HasDragMoveHandlers`, `HasDragRepositionMoveHandlers`, `HasDragRepositionStartHandlers`, `HasDragRepositionStopHandlers`, `HasDragResizeMoveHandlers`, `HasDragResizeStartHandlers`, `HasDragResizeStopHandlers`, `HasDragStartHandlers`, `HasDragStopHandlers`, `HasDropHandlers`, `HasDropMoveHandlers`, `HasDropOutHandlers`, `HasDropOverHandlers`, `HasFocusChangedHandlers`, `HasHoverHandlers`, `HasHoverHiddenHandlers`, `HasKeyDownHandlers`, `HasKeyPressHandlers`, `HasMouseDownHandlers`, `HasMouseMoveHandlers`, `HasMouseOutHandlers`, `HasMouseOverHandlers`, `HasMouseStillDownHandlers`, `HasMouseUpHandlers`, `HasMouseWheelHandlers`, `HasMovedHandlers`, `HasParentMovedHandlers`, `HasResizedHandlers`, `HasRightMouseDownHandlers`, `HasRuleContextChangedHandlers`, `HasScrolledHandlers`, `HasShowContextMenuHandlers`, `HasVisibilityChangedHandlers`, `HasMembersChangedHandlers`

public class RichTextEditor extends VLayout
RichTextEditing component. Provides a rich-text editing area along with UI for executing rich-text commands on selected content.

The HTML generated from this component may vary by browser, and, as with any HTML value created on the client, we recommend values be sanitized on the server before storing and displaying to other users.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

  `UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

  `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

  ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

  `DEBUG_ID_PREFIX`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RichTextEditor()`
  `RichTextEditor(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `changeAutoChildDefaults(String autoChildName, Canvas defaults)`
  Changes the defaults for Canvas AutoChildren named `autoChildName`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, FormItem defaults)`
  Changes the defaults for FormItem AutoChildren named `autoChildName`.
  `protected JavaScriptObject`
  `create()`
  `void`
  `doWarn()`
  Display a warning if Rich Text Editing is not fully supported in this browser.
  `String`
  `getAlignCenterPrompt()`
  The prompt for the built-in `alignCenter` control.
  `String`
  `getAlignLeftPrompt()`
  The prompt for the built-in `alignLeft` control.
  `String`
  `getAlignRightPrompt()`
  The prompt for the built-in `alignRight` control.
  `String`
  `getBackgroundColorPrompt()`
  The prompt for the built-in `backgroundColor` control.
  `String`
  `getBoldSelectionPrompt()`
  The prompt for the built-in `boldSelection` control.
  `String`
  `getColorPrompt()`
  The prompt for the built-in `color` control.
  `String`
  `getCopySelectionPrompt()`
  The prompt for the built-in `copySelection` control.
  `String`
  `getCutSelectionPrompt()`
  The prompt for the built-in `cutSelection` control.
  `Canvas`
  `getEditArea()`
  The edit canvas created automatically for this RichTextEditor.
  `String`
  `getEditAreaBackgroundColor()`
  Background color for the `edit canvas`.
  `final Map<String,String>`
  `getFontNames()`
  ValueMap of CSS fontName properties to font name titles to display in the font selector for the `FONTSELECTOR` control.
  `SelectItem`
  `getFontSelectorItem()`
  The `com.smartgwt.client.types.AutoChild` `SelectItem` used for choosing the font to apply to the current selection.
  `String`
  `getFontSelectorPrompt()`
  The prompt for the built-in `font selector`.
  `final Map<String,String>`
  `getFontSizes()`
  ValueMap of CSS font size property values to font size titles to display in the font size selector for the `FONTSIZESELECTOR` control.
  `SelectItem`
  `getFontSizeSelectorItem()`
  The `com.smartgwt.client.types.AutoChild` `SelectItem` used for choosing the font-size to apply to the current selection.
  `String`
  `getFontSizeSelectorPrompt()`
  The prompt for the built-in `font-size selector`.
  `String`
  `getIndentPrompt()`
  The prompt for the built-in `indent` control.
  `String`
  `getItalicSelectionPrompt()`
  The prompt for the built-in `italicSelection` control.
  `String`
  `getJustifyPrompt()`
  The prompt for the built-in `justify` control.
  `ListPropertiesDialog`
  `getListPropertiesDialog()`
  Dialog shown when the `"listProperties" control` is pressed.
  `String`
  `getListPropertiesPrompt()`
  The prompt for the built-in `listProperties` control.
  `String`
  `getListPropertiesWarningText()`
  The warning message displayed in a dialog when a user tries to configure a list without first putting the cursor in an appropriate place.
  `LogicalStructureObject`
  `getLogicalStructure()`
  Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `boolean`
  `getMoveFocusOnTab()`
  If the user presses the "Tab" key, should focus be taken from this editor? If set to `false` a "Tab" keypress will cause a Tab character to be inserted into the text, and focus will be left in the edit area.
  `static RichTextEditor`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `String`
  `getOrderedListPrompt()`
  The prompt for the built-in `orderedList` control.
  `String`
  `getOutdentPrompt()`
  The prompt for the built-in `outdent` control.
  `String`
  `getPasteSelectionPrompt()`
  The prompt for the built-in `pasteSelection` control.
  `String`
  `getStrikethroughSelectionPrompt()`
  The prompt for the built-in `strikethroughSelection` control.
  `Boolean`
  `getStyleWithCSS()`
  When true, applies style attributes in markup instead of presentation elements.
  `Layout`
  `getToolArea()`
  Layout used to contain all of the `toolbar` AutoChildren that contain the `controlGroups`.
  `Layout`
  `getToolbar()`
  Note : This API is non-functional (always returns null) and exists only to make you aware that this MultiAutoChild exists.
  `String`
  `getToolbarBackgroundColor()`
  The background color for the toolbar.
  `String`
  `getUnderlineSelectionPrompt()`
  The prompt for the built-in `underlineSelection` control.
  `String`
  `getUnorderedListPrompt()`
  The prompt for the built-in `unorderedList` control.
  `Boolean`
  `getUseDesignMode()`
  Should this editor use a separate IFRAME with special cross-browser support for editing HTML content? In Smart GWT versions 13.0 and later, this feature is switched off on account of better modern browser support for contentEditable containers.
  `String`
  `getValue()`
  Initial value for the edit area.
  `Boolean`
  `richEditorSupported()`
  Does this browser support the full RichTextEditor feature set.
  `RichTextEditor`
  `setAlignCenterPrompt(String alignCenterPrompt)`
  The prompt for the built-in `alignCenter` control.
  `RichTextEditor`
  `setAlignLeftPrompt(String alignLeftPrompt)`
  The prompt for the built-in `alignLeft` control.
  `RichTextEditor`
  `setAlignRightPrompt(String alignRightPrompt)`
  The prompt for the built-in `alignRight` control.
  `RichTextEditor`
  `setBackgroundColorPrompt(String backgroundColorPrompt)`
  The prompt for the built-in `backgroundColor` control.
  `RichTextEditor`
  `setBoldSelectionPrompt(String boldSelectionPrompt)`
  The prompt for the built-in `boldSelection` control.
  `RichTextEditor`
  `setBulletControls(ControlName... bulletControls)`
  Default HTML list control group.
  `void`
  `setBulletControls(Object... bulletControls)`
  Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setBulletControls(ControlName... bulletControls)`
  `RichTextEditor`
  `setColorControls(ControlName... colorControls)`
  Control group for modifying text color / background color.
  `void`
  `setColorControls(Object... colorControls)`
  Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setColorControls(ControlName... colorControls)`
  `RichTextEditor`
  `setColorPrompt(String colorPrompt)`
  The prompt for the built-in `color` control.
  `void`
  `setControlGroups(Object... controlGroups)`
  An array of control groups specifying which groups of controls should be included in the editor tool area.
  `void`
  `setControlGroups(String... controlGroups)`
  An array of control group names specifying which groups of controls should be included in the editor tool area.
  `RichTextEditor`
  `setCopySelectionPrompt(String copySelectionPrompt)`
  The prompt for the built-in `copySelection` control.
  `RichTextEditor`
  `setCutSelectionPrompt(String cutSelectionPrompt)`
  The prompt for the built-in `cutSelection` control.
  `static void`
  `setDefaultProperties(RichTextEditor richTextEditorProperties)`
  Class level method to set the default properties of this class.
  `RichTextEditor`
  `setEditAreaBackgroundColor(String editAreaBackgroundColor)`
  Background color for the `edit canvas`.
  `RichTextEditor`
  `setFontControls(ControlName... fontControls)`
  Default font control group.
  `void`
  `setFontControls(Object... fontControls)`
  Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setFontControls(ControlName... fontControls)`
  `void`
  `setFontNames(LinkedHashMap<String,String> fontNames)`
  ValueMap of CSS fontName properties to font name titles to display in the font selector for the `FONTSELECTOR` control.
  `RichTextEditor`
  `setFontSelectorPrompt(String fontSelectorPrompt)`
  The prompt for the built-in `font selector`.
  `void`
  `setFontSizes(LinkedHashMap<String,String> fontSizes)`
  ValueMap of CSS font size property values to font size titles to display in the font size selector for the `FONTSIZESELECTOR` control.
  `RichTextEditor`
  `setFontSizeSelectorPrompt(String fontSizeSelectorPrompt)`
  The prompt for the built-in `font-size selector`.
  `RichTextEditor`
  `setFormatControls(ControlName... formatControls)`
  Default text formatting control group.
  `void`
  `setFormatControls(Object... formatControls)`
  Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setFormatControls(ControlName... formatControls)`
  `RichTextEditor`
  `setIndentPrompt(String indentPrompt)`
  The prompt for the built-in `indent` control.
  `RichTextEditor`
  `setItalicSelectionPrompt(String italicSelectionPrompt)`
  The prompt for the built-in `italicSelection` control.
  `RichTextEditor`
  `setJustifyPrompt(String justifyPrompt)`
  The prompt for the built-in `justify` control.
  `RichTextEditor`
  `setListPropertiesPrompt(String listPropertiesPrompt)`
  The prompt for the built-in `listProperties` control.
  `RichTextEditor`
  `setListPropertiesWarningText(String listPropertiesWarningText)`
  The warning message displayed in a dialog when a user tries to configure a list without first putting the cursor in an appropriate place.
  `LogicalStructureObject`
  `setLogicalStructure(RichTextEditorLogicalStructure s)`
  Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `RichTextEditor`
  `setMoveFocusOnTab(boolean moveFocusOnTab)`
  If the user presses the "Tab" key, should focus be taken from this editor? If set to `false` a "Tab" keypress will cause a Tab character to be inserted into the text, and focus will be left in the edit area.
  `RichTextEditor`
  `setOrderedListPrompt(String orderedListPrompt)`
  The prompt for the built-in `orderedList` control.
  `RichTextEditor`
  `setOutdentPrompt(String outdentPrompt)`
  The prompt for the built-in `outdent` control.
  `RichTextEditor`
  `setPasteSelectionPrompt(String pasteSelectionPrompt)`
  The prompt for the built-in `pasteSelection` control.
  `RichTextEditor`
  `setStrikethroughSelectionPrompt(String strikethroughSelectionPrompt)`
  The prompt for the built-in `strikethroughSelection` control.
  `RichTextEditor`
  `setStyleControls(ControlName... styleControls)`
  Default text styling control group.
  `void`
  `setStyleControls(Object... styleControls)`
  Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setStyleControls(ControlName... styleControls)`
  `RichTextEditor`
  `setStyleWithCSS(Boolean styleWithCSS)`
  When true, applies style attributes in markup instead of presentation elements.
  `RichTextEditor`
  `setToolbarBackgroundColor(String toolbarBackgroundColor)`
  The background color for the toolbar.
  `RichTextEditor`
  `setUnderlineSelectionPrompt(String underlineSelectionPrompt)`
  The prompt for the built-in `underlineSelection` control.
  `RichTextEditor`
  `setUnorderedListPrompt(String unorderedListPrompt)`
  The prompt for the built-in `unorderedList` control.
  `RichTextEditor`
  `setUseDesignMode(Boolean useDesignMode)`
  Should this editor use a separate IFRAME with special cross-browser support for editing HTML content? In Smart GWT versions 13.0 and later, this feature is switched off on account of better modern browser support for contentEditable containers.
  `RichTextEditor`
  `setValue(String value)`
  Initial value for the edit area.

  ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

  `setDefaultProperties, setLogicalStructure`

  ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

  `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getChildTabPosition, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEditProxyConstructor, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutEndMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutStartMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersAsStringArray, getMembersLength, getMembersMargin, getMinMemberLength, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit, onInit_Layout, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, replaceMember, revealChild, revealChild, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEditProxyConstructor, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutEndMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutStartMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembers, setMembersMargin, setMinBreadthMember, setMinBreadthMember, setMinBreadthMember, setMinMemberLength, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

  ### Methods inherited from class com.smartgwt.client.widgets.Canvas

  `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsEventTarget, containsFocus, containsPoint, containsPoint, contentsComponentConnected, dataContextChanged, dataContextCriteriaChanged, deparent, depeer, disable, doValueDictation, doVoiceCommand, enable, encloses, endBatchCreation, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAllCanvases, getAllCanvases, getAllCanvases, getAlwaysManageFocusNavigation, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeLayoutMode, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaHandleID, getAriaRole, getAriaStateDefaults, getAutoMaskComponents, getAutoParent, getAutoPopulateData, getAutoRevertStyles, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBorderRadius, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanDropContent, getCanDropFiles, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenAsStringArray, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContentsComponentDefaults, getContextMenu, getControlHeight, getCorrectZoomOverflow, getCursor, getDataContext, getDataContextCriteria, getDataContextCriteria, getDataPath, getDefaultHeight, getDefaultWidth, getDeferActionConversion, getDefiningProperty, getDefiningPropertyName, getDefiningPropertyNameOptions, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragTargetAsString, getDragType, getDropTarget, getDropTargetAsString, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getEvents, getExtraSpace, getFacetId, getFloatingScrollbars, getFormItemAutoChild, getForwardSVGeventsToObject, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupPadding, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverPersist, getHoverScreen, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlElementAsString, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeaveGroupLabelSpace, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateByIDOnly, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getLocatorName, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMatchElementHeight, getMatchElementWidth, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getName, getNativeAutoHideScrollbars, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentCanvasAsString, getParentElement, getParentElementAsString, getPeers, getPendingMarkerStyle, getPendingMarkerVisible, getPercentBox, getPercentSource, getPersistentMatchElement, getPointerSettings, getPointerTarget, getPointerTargetAsString, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrintStyleName, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getReceiveScrollbarEvents, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShareCriteria, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowFocusOutline, getShowHover, getShowHoverComponents, getShowPointer, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSingleDiv, getSizeMayChangeOnRedraw, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapGridLineProperties, getSnapGridStyle, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getStyleName, getSuppressRedraw, getTabIndex, getTestDataContext, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getTopLevelComponents, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseBackMask, getUseCSSShadow, getUseDataContextCriteria, getUseDragMask, getUseGeneratedStyles, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getWorkflows, getZIndex, getZIndex, handleDataContextCriteria, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, initComplete, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, print, print, print, print, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, registerAIService, registerFontScaledPaddingStyles, removeChild, removeChild, removePeer, removePeer, removeRuleContext, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeControlsTo, resizeFonts, resizeFonts, resizeFonts, resizeFontsTo, resizeIcons, resizePadding, resizePadding, resizeTo, resizeTo, resolveContentsComponent, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysManageFocusNavigation, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeLayoutMode, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoPopulateData, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoRevertStyles, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBorderRadius, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanDropContent, setCanDropFiles, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContentsComponentDefaults, setContextMenu, setCorrectZoomOverflow, setCursor, setDataContext, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataPath, setDefaultHeight, setDefaultNativeAutoHideScrollbars, setDefaultPageSpace, setDefaultProperties, setDefaultShowCustomScrollbars, setDefaultWidth, setDeferActionConversion, setDefiningProperty, setDefiningPropertyNameOptions, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragTarget, setDragType, setDropTarget, setDropTarget, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setFloatingScrollbars, setForwardSVGeventsToObject, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupPadding, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverPersist, setHoverScreen, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeaveGroupLabelSpace, setLeavePageSpace, setLeft, setLeft, setLocateByIDOnly, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLocatorName, setLocatorParent, setLocatorParent, setLogicalStructure, setMargin, setMatchElement, setMatchElementHeight, setMatchElementWidth, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setName, setNativeAutoHideScrollbars, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentCanvas, setParentElement, setParentElement, setPeers, setPendingMarkerStyle, setPendingMarkerVisible, setPercentBox, setPercentSource, setPersistentMatchElement, setPointerSettings, setPointerTarget, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrintStyleName, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setReceiveScrollbarEvents, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShareCriteria, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowFocusOutline, setShowHover, setShowHoverComponents, setShowPointer, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSingleDiv, setSizeMayChangeOnRedraw, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapGridLineProperties, setSnapGridStyle, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setStyleName, setSuppressRedraw, setTabIndex, setTestDataContext, setTitle, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseBackMask, setUseCSSShadow, setUseDataContextCriteria, setUseDragMask, setUseGeneratedStyles, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setWorkflows, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPendingMarker, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, startBatchCreation, startDebuggingOverflow, stopDebuggingOverflow, subtractRects, supportsValueDictation, supportsVoiceCommands, unregisterAIService, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint, willAcceptDrop`

  ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

  `addDrawHandler, addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, clearDynamicProperty, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAutoDraw, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hasDynamicProperty, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoDraw, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

  ### Methods inherited from class com.google.gwt.user.client.ui.Widget

  `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

  ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

  `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

  `fireEvent`

- ## Constructor Details

  - ### RichTextEditor

    public RichTextEditor()

  - ### RichTextEditor

    public RichTextEditor(JavaScriptObject jsObj)

- ## Method Details

  - ### getOrCreateRef

    public static RichTextEditor getOrCreateRef(JavaScriptObject jsObj)

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, Canvas defaults)
    Changes the defaults for Canvas AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, FormItem defaults)
    Changes the defaults for FormItem AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### create

    protected JavaScriptObject create()
    Overrides:
      `create` in class `VLayout`

  - ### setAlignCenterPrompt

    public RichTextEditor setAlignCenterPrompt(String alignCenterPrompt)
    The prompt for the built-in `alignCenter` control.
    Parameters:
      `alignCenterPrompt` - New alignCenterPrompt value. Default value is "Center selection"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getAlignCenterPrompt

    public String getAlignCenterPrompt()
    The prompt for the built-in `alignCenter` control.
    Returns:
      Current alignCenterPrompt value. Default value is "Center selection"

  - ### setAlignLeftPrompt

    public RichTextEditor setAlignLeftPrompt(String alignLeftPrompt)
    The prompt for the built-in `alignLeft` control.
    Parameters:
      `alignLeftPrompt` - New alignLeftPrompt value. Default value is "Left align selection"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getAlignLeftPrompt

    public String getAlignLeftPrompt()
    The prompt for the built-in `alignLeft` control.
    Returns:
      Current alignLeftPrompt value. Default value is "Left align selection"

  - ### setAlignRightPrompt

    public RichTextEditor setAlignRightPrompt(String alignRightPrompt)
    The prompt for the built-in `alignRight` control.
    Parameters:
      `alignRightPrompt` - New alignRightPrompt value. Default value is "Right align selection"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getAlignRightPrompt

    public String getAlignRightPrompt()
    The prompt for the built-in `alignRight` control.
    Returns:
      Current alignRightPrompt value. Default value is "Right align selection"

  - ### setBackgroundColorPrompt

    public RichTextEditor setBackgroundColorPrompt(String backgroundColorPrompt)
    The prompt for the built-in `backgroundColor` control.
    Parameters:
      `backgroundColorPrompt` - New backgroundColorPrompt value. Default value is "Set selection background color"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getBackgroundColorPrompt

    public String getBackgroundColorPrompt()
    The prompt for the built-in `backgroundColor` control.
    Returns:
      Current backgroundColorPrompt value. Default value is "Set selection background color"

  - ### setBoldSelectionPrompt

    public RichTextEditor setBoldSelectionPrompt(String boldSelectionPrompt)
    The prompt for the built-in `boldSelection` control.
    Parameters:
      `boldSelectionPrompt` - New boldSelectionPrompt value. Default value is "Make selection bold"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getBoldSelectionPrompt

    public String getBoldSelectionPrompt()
    The prompt for the built-in `boldSelection` control.
    Returns:
      Current boldSelectionPrompt value. Default value is "Make selection bold"

  - ### setBulletControls

    public RichTextEditor setBulletControls(ControlName... bulletControls) throws IllegalStateException
    Default HTML list control group. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"bulletControls"` in the `controlGroups` array.

    Note : This is an advanced setting

    Parameters:
      `bulletControls` - New bulletControls value. Default value is ["indent", "outdent", "orderedList", "unorderedList", "listProperties"]
    Returns:
      `RichTextEditor` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### setColorControls

    public RichTextEditor setColorControls(ControlName... colorControls) throws IllegalStateException
    Control group for modifying text color / background color. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"formatControls"` in the `controlGroups` array.

    Note : This is an advanced setting

    Parameters:
      `colorControls` - New colorControls value. Default value is ["color", "backgroundColor"]
    Returns:
      `RichTextEditor` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### setColorPrompt

    public RichTextEditor setColorPrompt(String colorPrompt)
    The prompt for the built-in `color` control.
    Parameters:
      `colorPrompt` - New colorPrompt value. Default value is "Set selection text color"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getColorPrompt

    public String getColorPrompt()
    The prompt for the built-in `color` control.
    Returns:
      Current colorPrompt value. Default value is "Set selection text color"

  - ### setCopySelectionPrompt

    public RichTextEditor setCopySelectionPrompt(String copySelectionPrompt)
    The prompt for the built-in `copySelection` control.
    Parameters:
      `copySelectionPrompt` - New copySelectionPrompt value. Default value is "Copy Selection"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getCopySelectionPrompt

    public String getCopySelectionPrompt()
    The prompt for the built-in `copySelection` control.
    Returns:
      Current copySelectionPrompt value. Default value is "Copy Selection"

  - ### setCutSelectionPrompt

    public RichTextEditor setCutSelectionPrompt(String cutSelectionPrompt)
    The prompt for the built-in `cutSelection` control.
    Parameters:
      `cutSelectionPrompt` - New cutSelectionPrompt value. Default value is "Cut Selection"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getCutSelectionPrompt

    public String getCutSelectionPrompt()
    The prompt for the built-in `cutSelection` control.
    Returns:
      Current cutSelectionPrompt value. Default value is "Cut Selection"

  - ### getEditArea

    public Canvas getEditArea() throws IllegalStateException
    The edit canvas created automatically for this RichTextEditor.

    This component is an AutoChild named "editArea". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current editArea value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setEditAreaBackgroundColor

    public RichTextEditor setEditAreaBackgroundColor(String editAreaBackgroundColor) throws IllegalStateException
    Background color for the `edit canvas`.
    Parameters:
      `editAreaBackgroundColor` - New editAreaBackgroundColor value. Default value is "white"
    Returns:
      `RichTextEditor` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getEditAreaBackgroundColor

    public String getEditAreaBackgroundColor()
    Background color for the `edit canvas`.
    Returns:
      Current editAreaBackgroundColor value. Default value is "white"

  - ### setFontControls

    public RichTextEditor setFontControls(ControlName... fontControls) throws IllegalStateException
    Default font control group. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"fontControls"` in the `controlGroups` array.

    Note : This is an advanced setting

    Parameters:
      `fontControls` - New fontControls value. Default value is ["fontSelector", "fontSizeSelector"]
    Returns:
      `RichTextEditor` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getFontSelectorItem

    public SelectItem getFontSelectorItem() throws IllegalStateException
    The `com.smartgwt.client.types.AutoChild` `SelectItem` used for choosing the font to apply to the current selection.

    This component is an AutoChild named "fontSelectorItem". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current fontSelectorItem value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setFontSelectorPrompt

    public RichTextEditor setFontSelectorPrompt(String fontSelectorPrompt)
    The prompt for the built-in `font selector`.
    Parameters:
      `fontSelectorPrompt` - New fontSelectorPrompt value. Default value is "Set Font..."
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getFontSelectorPrompt

    public String getFontSelectorPrompt()
    The prompt for the built-in `font selector`.
    Returns:
      Current fontSelectorPrompt value. Default value is "Set Font..."

  - ### getFontSizeSelectorItem

    public SelectItem getFontSizeSelectorItem() throws IllegalStateException
    The `com.smartgwt.client.types.AutoChild` `SelectItem` used for choosing the font-size to apply to the current selection.

    This component is an AutoChild named "fontSizeSelectorItem". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current fontSizeSelectorItem value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setFontSizeSelectorPrompt

    public RichTextEditor setFontSizeSelectorPrompt(String fontSizeSelectorPrompt)
    The prompt for the built-in `font-size selector`.
    Parameters:
      `fontSizeSelectorPrompt` - New fontSizeSelectorPrompt value. Default value is "Set Font Size..."
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getFontSizeSelectorPrompt

    public String getFontSizeSelectorPrompt()
    The prompt for the built-in `font-size selector`.
    Returns:
      Current fontSizeSelectorPrompt value. Default value is "Set Font Size..."

  - ### setFormatControls

    public RichTextEditor setFormatControls(ControlName... formatControls) throws IllegalStateException
    Default text formatting control group. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"formatControls"` in the `controlGroups` array.

    Note : This is an advanced setting

    Parameters:
      `formatControls` - New formatControls value. Default value is ["alignLeft", "alignRight", "alignCenter", "justify"]
    Returns:
      `RichTextEditor` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### setIndentPrompt

    public RichTextEditor setIndentPrompt(String indentPrompt)
    The prompt for the built-in `indent` control.
    Parameters:
      `indentPrompt` - New indentPrompt value. Default value is "Increase Indent"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getIndentPrompt

    public String getIndentPrompt()
    The prompt for the built-in `indent` control.
    Returns:
      Current indentPrompt value. Default value is "Increase Indent"

  - ### setItalicSelectionPrompt

    public RichTextEditor setItalicSelectionPrompt(String italicSelectionPrompt)
    The prompt for the built-in `italicSelection` control.
    Parameters:
      `italicSelectionPrompt` - New italicSelectionPrompt value. Default value is "Make selection italic"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getItalicSelectionPrompt

    public String getItalicSelectionPrompt()
    The prompt for the built-in `italicSelection` control.
    Returns:
      Current italicSelectionPrompt value. Default value is "Make selection italic"

  - ### setJustifyPrompt

    public RichTextEditor setJustifyPrompt(String justifyPrompt)
    The prompt for the built-in `justify` control.
    Parameters:
      `justifyPrompt` - New justifyPrompt value. Default value is "Full justify selection"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getJustifyPrompt

    public String getJustifyPrompt()
    The prompt for the built-in `justify` control.
    Returns:
      Current justifyPrompt value. Default value is "Full justify selection"

  - ### getListPropertiesDialog

    public ListPropertiesDialog getListPropertiesDialog() throws IllegalStateException
    Dialog shown when the `"listProperties" control` is pressed. Provides options for the user to control formatting of lists.

    This component is an AutoChild named "listPropertiesDialog". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current listPropertiesDialog value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setListPropertiesPrompt

    public RichTextEditor setListPropertiesPrompt(String listPropertiesPrompt)
    The prompt for the built-in `listProperties` control.
    Parameters:
      `listPropertiesPrompt` - New listPropertiesPrompt value. Default value is "Configure the list"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getListPropertiesPrompt

    public String getListPropertiesPrompt()
    The prompt for the built-in `listProperties` control.
    Returns:
      Current listPropertiesPrompt value. Default value is "Configure the list"

  - ### setListPropertiesWarningText

    public RichTextEditor setListPropertiesWarningText(String listPropertiesWarningText)
    The warning message displayed in a dialog when a user tries to configure a list without first putting the cursor in an appropriate place.
    Parameters:
      `listPropertiesWarningText` - New listPropertiesWarningText value. Default value is "Place the cursor within a list to configure it"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getListPropertiesWarningText

    public String getListPropertiesWarningText()
    The warning message displayed in a dialog when a user tries to configure a list without first putting the cursor in an appropriate place.
    Returns:
      Current listPropertiesWarningText value. Default value is "Place the cursor within a list to configure it"

  - ### setMoveFocusOnTab

    public RichTextEditor setMoveFocusOnTab(boolean moveFocusOnTab)
    If the user presses the "Tab" key, should focus be taken from this editor? If set to `false` a "Tab" keypress will cause a Tab character to be inserted into the text, and focus will be left in the edit area.
    If this method is called after the component has been drawn/initialized: Setter for `moveFocusOnTab`.
    Parameters:
      `moveFocusOnTab` - new value for moveFocusOnTab. Default value is true
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getMoveFocusOnTab

    public boolean getMoveFocusOnTab()
    If the user presses the "Tab" key, should focus be taken from this editor? If set to `false` a "Tab" keypress will cause a Tab character to be inserted into the text, and focus will be left in the edit area.
    Returns:
      Current moveFocusOnTab value. Default value is true

  - ### setOrderedListPrompt

    public RichTextEditor setOrderedListPrompt(String orderedListPrompt)
    The prompt for the built-in `orderedList` control.
    Parameters:
      `orderedListPrompt` - New orderedListPrompt value. Default value is "Convert to a numbered list"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getOrderedListPrompt

    public String getOrderedListPrompt()
    The prompt for the built-in `orderedList` control.
    Returns:
      Current orderedListPrompt value. Default value is "Convert to a numbered list"

  - ### setOutdentPrompt

    public RichTextEditor setOutdentPrompt(String outdentPrompt)
    The prompt for the built-in `outdent` control.
    Parameters:
      `outdentPrompt` - New outdentPrompt value. Default value is "Decrease Indent"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getOutdentPrompt

    public String getOutdentPrompt()
    The prompt for the built-in `outdent` control.
    Returns:
      Current outdentPrompt value. Default value is "Decrease Indent"

  - ### setPasteSelectionPrompt

    public RichTextEditor setPasteSelectionPrompt(String pasteSelectionPrompt)
    The prompt for the built-in `pasteSelection` control.
    Parameters:
      `pasteSelectionPrompt` - New pasteSelectionPrompt value. Default value is "Paste"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getPasteSelectionPrompt

    public String getPasteSelectionPrompt()
    The prompt for the built-in `pasteSelection` control.
    Returns:
      Current pasteSelectionPrompt value. Default value is "Paste"

  - ### setStrikethroughSelectionPrompt

    public RichTextEditor setStrikethroughSelectionPrompt(String strikethroughSelectionPrompt)
    The prompt for the built-in `strikethroughSelection` control.
    Parameters:
      `strikethroughSelectionPrompt` - New strikethroughSelectionPrompt value. Default value is "Strike through selection"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getStrikethroughSelectionPrompt

    public String getStrikethroughSelectionPrompt()
    The prompt for the built-in `strikethroughSelection` control.
    Returns:
      Current strikethroughSelectionPrompt value. Default value is "Strike through selection"

  - ### setStyleControls

    public RichTextEditor setStyleControls(ControlName... styleControls) throws IllegalStateException
    Default text styling control group. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"styleControls"` in the `controlGroups` array.

    Note : This is an advanced setting

    Parameters:
      `styleControls` - New styleControls value. Default value is ["boldSelection", "italicSelection", "underlineSelection"]
    Returns:
      `RichTextEditor` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### setStyleWithCSS

    public RichTextEditor setStyleWithCSS(Boolean styleWithCSS) throws IllegalStateException
    When true, applies style attributes in markup instead of presentation elements.

    Note : This is an advanced setting

    Parameters:
      `styleWithCSS` - New styleWithCSS value. Default value is null
    Returns:
      `RichTextEditor` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getStyleWithCSS

    public Boolean getStyleWithCSS()
    When true, applies style attributes in markup instead of presentation elements.
    Returns:
      Current styleWithCSS value. Default value is null

  - ### getToolArea

    public Layout getToolArea() throws IllegalStateException
    Layout used to contain all of the `toolbar` AutoChildren that contain the `controlGroups`.

    This component is an AutoChild named "toolArea". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current toolArea value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### getToolbar

    public Layout getToolbar()
    Note : This API is non-functional (always returns null) and exists only to make you aware that this MultiAutoChild exists. See `Using AutoChildren` for details.

    Layout used to contain each of the `controlGroups`.

    Returns:
      null

  - ### setToolbarBackgroundColor

    public RichTextEditor setToolbarBackgroundColor(String toolbarBackgroundColor) throws IllegalStateException
    The background color for the toolbar.
    Parameters:
      `toolbarBackgroundColor` - New toolbarBackgroundColor value. Default value is "#CCCCCC"
    Returns:
      `RichTextEditor` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getToolbarBackgroundColor

    public String getToolbarBackgroundColor()
    The background color for the toolbar.
    Returns:
      Current toolbarBackgroundColor value. Default value is "#CCCCCC"

  - ### setUnderlineSelectionPrompt

    public RichTextEditor setUnderlineSelectionPrompt(String underlineSelectionPrompt)
    The prompt for the built-in `underlineSelection` control.
    Parameters:
      `underlineSelectionPrompt` - New underlineSelectionPrompt value. Default value is "Make selection underlined"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getUnderlineSelectionPrompt

    public String getUnderlineSelectionPrompt()
    The prompt for the built-in `underlineSelection` control.
    Returns:
      Current underlineSelectionPrompt value. Default value is "Make selection underlined"

  - ### setUnorderedListPrompt

    public RichTextEditor setUnorderedListPrompt(String unorderedListPrompt)
    The prompt for the built-in `unorderedList` control.
    Parameters:
      `unorderedListPrompt` - New unorderedListPrompt value. Default value is "Convert to a bullet list"
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getUnorderedListPrompt

    public String getUnorderedListPrompt()
    The prompt for the built-in `unorderedList` control.
    Returns:
      Current unorderedListPrompt value. Default value is "Convert to a bullet list"

  - ### setUseDesignMode

    public RichTextEditor setUseDesignMode(Boolean useDesignMode) throws IllegalStateException
    Should this editor use a separate IFRAME with special cross-browser support for editing HTML content? In Smart GWT versions 13.0 and later, this feature is switched off on account of better modern browser support for contentEditable containers.

    Note : This is an advanced setting

    Parameters:
      `useDesignMode` - New useDesignMode value. Default value is false
    Returns:
      `RichTextEditor` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getUseDesignMode

    public Boolean getUseDesignMode()
    Should this editor use a separate IFRAME with special cross-browser support for editing HTML content? In Smart GWT versions 13.0 and later, this feature is switched off on account of better modern browser support for contentEditable containers.
    Returns:
      Current useDesignMode value. Default value is false

  - ### setValue

    public RichTextEditor setValue(String value)
    Initial value for the edit area. Use `getValue()` and `setValue()` to update at runtime.
    If this method is called after the component has been drawn/initialized: Updates the current value of the edit area.
    Parameters:
      `value` - New value value. Default value is ""
    Returns:
      `RichTextEditor` instance, for chaining setter calls

  - ### getValue

    public String getValue()
    Initial value for the edit area. Use `getValue()` and `setValue()` to update at runtime.
    Returns:
      Retrieves the current value of the edit area. Default value is ""

  - ### doWarn

    public void doWarn()
    Display a warning if Rich Text Editing is not fully supported in this browser. Default behavior logs a warning to the developer console - Override this if a user-visible warning is required

  - ### richEditorSupported

    public Boolean richEditorSupported()
    Does this browser support the full RichTextEditor feature set. Returns false for browsers in which some features are not natively supported (Safari before version 3.1 and Opera before version 9.50).
    Returns:
      false if this browser doesn't fully support RichTextEditing

  - ### setDefaultProperties

    public static void setDefaultProperties(RichTextEditor richTextEditorProperties)
    Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

    Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

    Parameters:
      `richTextEditorProperties` - properties that should be used as new defaults when instances of this class are created
    See Also:
      - `SGWTProperties`

  - ### setControlGroups

    public void setControlGroups(String... controlGroups)
    An array of control group names specifying which groups of controls should be included in the editor tool area. The special string "break" may also be included in this array to cause the subsequent control groups to continue onto a new line.
    Parameters:
      `controlGroups` - the control groups. Default is ["fontControls", "formatControls", "styleControls", "colorControls"]
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### setControlGroups

    public void setControlGroups(Object... controlGroups) throws IllegalStateException
    An array of control groups specifying which groups of controls should be included in the editor tool area. The values of this array may be a `StandardControlGroup` enum value, the name of a control group (String), a `Canvas`, or the special string "break" which causes the subsequent control groups to continue onto a new line.
    Parameters:
      `controlGroups` - the control groups. Default is [ `FONTCONTROLS`, `FORMATCONTROLS`, `STYLECONTROLS`, `COLORCONTROLS`].
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### setBulletControls

    public void setBulletControls(Object... bulletControls) throws IllegalStateException
    Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setBulletControls(ControlName... bulletControls)`
    Throws:
      `IllegalStateException`

  - ### setColorControls

    public void setColorControls(Object... colorControls) throws IllegalStateException
    Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setColorControls(ControlName... colorControls)`
    Throws:
      `IllegalStateException`

  - ### setFontControls

    public void setFontControls(Object... fontControls) throws IllegalStateException
    Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setFontControls(ControlName... fontControls)`
    Throws:
      `IllegalStateException`

  - ### setFormatControls

    public void setFormatControls(Object... formatControls) throws IllegalStateException
    Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setFormatControls(ControlName... formatControls)`
    Throws:
      `IllegalStateException`

  - ### setStyleControls

    public void setStyleControls(Object... styleControls) throws IllegalStateException
    Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setStyleControls(ControlName... styleControls)`
    Throws:
      `IllegalStateException`

  - ### getFontNames

    public final Map<String,String> getFontNames()
    ValueMap of CSS fontName properties to font name titles to display in the font selector for the `FONTSELECTOR` control.
    Returns:
      the current fontNames valueMap

  - ### setFontNames

    public void setFontNames(LinkedHashMap<String,String> fontNames) throws IllegalStateException
    ValueMap of CSS fontName properties to font name titles to display in the font selector for the `FONTSELECTOR` control.
    Parameters:
      `fontNames` - the new ValueMap
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getFontSizes

    public final Map<String,String> getFontSizes()
    ValueMap of CSS font size property values to font size titles to display in the font size selector for the `FONTSIZESELECTOR` control.
    Returns:
      the current fontNames valueMap

  - ### setFontSizes

    public void setFontSizes(LinkedHashMap<String,String> fontSizes) throws IllegalStateException
    ValueMap of CSS font size property values to font size titles to display in the font size selector for the `FONTSIZESELECTOR` control.
    Parameters:
      `fontSizes` - the new ValueMap
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### setLogicalStructure

    public LogicalStructureObject setLogicalStructure(RichTextEditorLogicalStructure s)
    Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

  - ### getLogicalStructure

    public LogicalStructureObject getLogicalStructure()
    Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    Specified by:
      `getLogicalStructure` in interface `LogicalStructure`
    Overrides:
      `getLogicalStructure` in class `VLayout`